
/*
 * Arduino Code for HMIP_OC8_Micro_V2.1
 * 
 * written by C.Epe, www.realHDaudio.de
 * 
 * Contact me for any problems.
 * 
 * This projects was made to connect HMIP-MOD-OC8 to an Arduino Micro to control Velux motors via Velux remote controls. 
 * Four remotes can be controlled providing up, down and stop fuctions on each Switch X (X=1-4).
 * All pin configurations and assignemts to a specific remote are based on a self made circuit board (HMIP_OC8_Micro_V2.1)
 * which can be downloaded from www.realHDaudio.de. Gerber-Files are provides to order pcbs.
 * 
 * No warranty!
 */ 
 
int Input[] = {0,1,2,3,4,5,6,7};  // an array of pin numbers to which HMIP-MOD-OC3 is attached
int pinCount_In = 8;              // variable for setup

int Output1[] = {12,10,11};       // an array of pin numbers to which a remote is attached over 74HC4066, X1
int Output2[] = {A0,8,9};         // an array of pin numbers to which a remote is attached over 74HC4066, X2
int Output3[] = {A3,A1,13};       // an array of pin numbers to which a remote is attached over 74HC4066, X3
int Output4[] = {A5,A4,A2};       // an array of pin numbers to which a remote is attached over 74HC4066, X4
int pinCount_Out = 3;


// Variables will change:
int lastinput1State = 0; 
int lastinput2State = 0; 
int lastinput3State = 0; 
int lastinput4State = 0; 
int lastinput5State = 0; 
int lastinput6State = 0; 
int lastinput7State = 0; 
int lastinput8State = 0;
 
int pushButtonHoldTime =100;      // Time or HOLD-TIME of pulse is given to the 74HC4066 in ms,  

void setup() {
  // set the digital pin as input or output:
  for (int thisPin_In = 0; thisPin_In < pinCount_In; thisPin_In++) {
    pinMode(Input[thisPin_In], INPUT_PULLUP);
  }
  for (int thisPin_Out = 0; thisPin_Out < pinCount_Out; thisPin_Out++) {
    pinMode(Output1[thisPin_Out], OUTPUT);
    pinMode(Output2[thisPin_Out], OUTPUT);
    pinMode(Output3[thisPin_Out], OUTPUT);
    pinMode(Output4[thisPin_Out], OUTPUT);
  }   
}

void loop()
{
  //read Inputs
  int input1State = digitalRead(1);
  int input2State = digitalRead(0);
  int input3State = digitalRead(2);
  int input4State = digitalRead(3);
  int input5State = digitalRead(4);
  int input6State = digitalRead(5);
  int input7State = digitalRead(6);
  int input8State = digitalRead(7);

 //Switch X = HMIP-MOD-OC8 Button
 //Remote X = Velux remote connected to connector X1, X2, X3 or X4
  
 //****************************************************************************************
 //SWITCH 1, Remote 1 Up and Down ****************************************************************
 //****************************************************************************************  
  // compare the buttonState to its previous state
  if (input1State != lastinput1State) {
        
        if (input1State == LOW) {
        // if the HMIP-MOD-OC8 Button 1 was set to HIGH the Output D12 of 74HC4066 became LOW=inputXstate 
        digitalWrite(12, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(12,LOW);
        } else {
        // if the HMIP-MOD-OC8 Button 1 was set to LOW the Output D11 of 74HC4066 became LOW=inputXstate 
        digitalWrite(11, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(11,LOW);
        }
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput1State = input1State;
 //****************************************************************************************
 //SWITCH 2, Remote 2 Up and Down**********************************************************
 //****************************************************************************************  
    // compare the buttonState to its previous state
  if (input2State != lastinput2State) {
        
        if (input2State == LOW) {
        // if the HMIP-MOD-OC8 Button 2 was set to HIGH the Output A0 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A0, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A0,LOW);
        } else {
        // if the HMIP-MOD-OC8 Button 2 was set to LOW the Output D9 of 74HC4066 became LOW=inputXstate 
        digitalWrite(9, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(9,LOW);
        }
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput2State = input2State;

 //****************************************************************************************
 //SWITCH 3, Remote 3 Up and Down *********************************************************
 //****************************************************************************************
    // compare the buttonState to its previous state
  if (input3State != lastinput3State) {
    // if the state has changed, increment the counter
        if (input3State == LOW) {
        // if the HMIP-MOD-OC8 Button 3 was set to HIGH the Output A3 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A3, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A3,LOW);
        } else {
        // if the HMIP-MOD-OC8 Button 3 was set to LOW the Output D13 of 74HC4066 became LOW=inputXstate 
        digitalWrite(13, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(13,LOW);
        }
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput3State = input3State;
 //****************************************************************************************
 //SWITCH 4, Remote 4 Up and Down********************************************************** 
 //****************************************************************************************  
     // compare the buttonState to its previous state
  if (input4State != lastinput4State) {
    // if the state has changed, increment the counter
        if (input4State == LOW) {
        // if the HMIP-MOD-OC8 Button 4 was set to HIGH the Output A5 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A5, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A5,LOW);
        } else {
        // if the HMIP-MOD-OC8 Button 4 was set to LOW the Output A2 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A2, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A2,LOW);
        }
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput4State = input4State; 
 //****************************************************************************************
 //SWITCH 5 , Remote 1 Stop *************************************************************** 
 //****************************************************************************************  
     // compare the buttonState to its previous state
  if (input5State != lastinput5State) {
    // if the state has changed, increment the counter
        if (input5State == LOW) {
        // if the HMIP-MOD-OC8 Button 5 was set to HIGH the Output D10 of 74HC4066 became LOW=inputXstate 
        digitalWrite(10, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(10,LOW);
        } else {
        //Do nothing
        }     
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput5State = input5State;  
 //*****************************************************************************************
 //SWITCH 6, Remote 2 Right Stop *********************************************************** 
 //*****************************************************************************************  
     // compare the buttonState to its previous state
  if (input6State != lastinput6State) {
    // if the state has changed, increment the counter
        if (input6State == LOW) {
        // if the HMIP-MOD-OC8 Button 6 was set to HIGH the Output D8 of 74HC4066 became LOW=inputXstate 
        digitalWrite(8, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(8,LOW);
        } else {
        //Do nothing
        }     
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput6State = input6State; 
 //*****************************************************************************************
 //SWITCH 7, Remote 3 Stop ***************************************************************** 
 //*****************************************************************************************  
     // compare the buttonState to its previous state
  if (input7State != lastinput7State) {
    // if the state has changed, increment the counter
        if (input7State == LOW) {
        // if the HMIP-MOD-OC8 Button 7 was set to HIGH the Output A1 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A1, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A1,LOW);
        } else {
        //Do nothing
        }     
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput7State = input7State; 
 //*****************************************************************************************
 //SWITCH 8, Remote 4 Stop ***************************************************************** 
 //*****************************************************************************************  
     // compare the buttonState to its previous state
  if (input8State != lastinput8State) {
    // if the state has changed, increment the counter
        if (input8State == LOW) {
        // if the HMIP-MOD-OC8 Button 8 was set to HIGH the Output A4 of 74HC4066 became LOW=inputXstate 
        digitalWrite(A4, HIGH);
        delay(pushButtonHoldTime);
        digitalWrite(A4,LOW);
        } else {
        //Do nothing
        }     
    // Delay a little bit to avoid bouncing
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastinput8State = input8State;     
}

